/***************************************************************************
 *   Copyright (C) 2007 by Marcin Swiechowicz   *
 *   marcin.swiechowicz@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef KDCBUILDDVDDISCSTRUCTUREJOB_H
#define KDCBUILDDVDDISCSTRUCTUREJOB_H

#include "kdcjob.h"
#include "../kdcdvddisc.h"

#include <QStringList>
#include <QTimerEvent>

#include <KProcess>

class KDCBuildDVDDiscStructureJob: public KDCJob
{
Q_OBJECT
public:
	KDCBuildDVDDiscStructureJob( KDCDVDDisc *disc, QObject *parent = 0 );
	~KDCBuildDVDDiscStructureJob();
	void start();
private slots:
	void on_readyReadStandardOutput();
	void on_finished( int , QProcess::ExitStatus );
protected:
	void timerEvent( QTimerEvent *event );
private:
	KProcess *p_process;
	double p_const;
	int p_totalSum;
	int p_prevTotalSum;
	int p_prevSize;
	QStringList p_files;
	KDCDVDDisc *p_disc;
	int p_timerID;
};
#endif
