/***************************************************************************
 *   Copyright (C) 2007 by Marcin Swiechowicz   *
 *   marcin.swiechowicz@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef KDCMOVIECONVERTJOB_H
#define KDCMOVIECONVERTJOB_H

#include "../kdcmovie.h"
#include "../kdcmoviegroup.h"
#include "kdcjob.h"

#include <QMap>
#include <QStringList>
#include <QTimerEvent>

#include <KProcess>

struct Expand
{
	int addX;
	int addY;
	int upX;
	int upY;
	KDC::AspectRatio ar;
};

class KDCMovieConvertJob: public KDCJob
{
Q_OBJECT
public:
	KDCMovieConvertJob( const KDCMovie *movie, QObject *parent = 0 );
	KDCMovieConvertJob( const KDCMovieGroup *group, QObject *parent = 0 );
	~KDCMovieConvertJob();
	void start();
	void setOutputFile( const QString& ); //call before start
private slots:
	void on_readyReadStandardOutput();
	void on_finished( int , QProcess::ExitStatus );
protected:
	Expand computeExpand( const KDCMovie *movie );
	QStringList prepareMovie( const KDCMovie *movie );
	QStringList writeHeader( KDC::DiscType type, double outFps );
	void timerEvent( QTimerEvent *event );
private:
	KProcess *p_process;
	QMap< int, QString > p_files;
	QMap< int, QString >::const_iterator p_it;
	bool p_copyA;
	bool p_copyV;
	double p_fps;
	int p_timerID;
};
#endif
