/***************************************************************************
 *   Copyright (C) 2007 by Marcin Swiechowicz   *
 *   marcin.swiechowicz@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef KDCONFLYPREVIEWJOB_H
#define KDCONFLYPREVIEWJOB_H

#include "../dialogs/kdcdialog.h"
#include "../kdcmovie.h"
#include "kdcmplayerjob.h"

#include "kdccompositejob.h"

#include <QTreeWidgetItem>
#include <QWidget>
#include <QPointer>
#include <QProgressBar>
#include <QString>

class KDCOnFlyPreviewJob: public KDCCompositeJob
{
Q_OBJECT
public:
	KDCOnFlyPreviewJob( QWidget *dialogParent, QObject *parent = 0 );
	~KDCOnFlyPreviewJob();
	void start();
signals:
	void done();
public slots:
	void setCurrentFrame( int );
	void show();
	void close();
	void setCurrentMovie( QTreeWidgetItem *movie );
private slots:
	void on_mplayerJobFinished( KDCJob * );
	void startClicked();
private:
	QPointer<KDCDialog> p_dlg;
	int p_pos;
	KDCMovie *p_movie;
	QPointer<KDCMPlayerJob> p_mJob;
	QWidget *p_parent;
	QProgressBar *p_bar;
	QString p_fileName;
};
#endif
