/***************************************************************************
 *   Copyright (C) 2007 by Marcin Swiechowicz   *
 *   marcin.swiechowicz@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef KDCREADFILEINFOJOB_H
#define KDCREADFILEINFOJOB_H

#include "../kdcvideostreammetadata.h"
#include "../kdcaudiostreammetadata.h"
#include "kdcreadfileinfosubjob.h"
#include "kdcjob.h"

#include <QStringList>
#include <QList>
#include <QPointer>

#include <KProcess>

class KDCReadFileInfoJob: public KDCJob
{
Q_OBJECT
public:
	KDCReadFileInfoJob( const QString& file, QObject *parent = 0 );
	~KDCReadFileInfoJob();
	void start();
signals:
	void movieInfo( const QString& , KDCVideoStreamMetaData *, const QList<KDCAudioStreamMetaData*>& );
	void description( const QString& );
	void noVideoStreamFound();
private slots:
	void on_foundAudioStreamID( const QList<int>& );
	void on_foundAudioStream( KDCAudioStreamMetaData * );
	void on_foundVideoStream( KDCVideoStreamMetaData * );
	void on_subjobFinished( KDCJob * );
	void on_finished( int, QProcess::ExitStatus );
private:
	QPointer<KProcess> p_process;
	QString p_fileName;
	QList<KDCAudioStreamMetaData*> p_audio;
	KDCVideoStreamMetaData *p_video;
	QPointer<KDCReadFileInfoSubjob> p_job;
	QList<int> p_audioID;
};
#endif
