/***************************************************************************
 *   Copyright (C) 2007 by Marcin Swiechowicz   *
 *   marcin.swiechowicz@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "kdcvideostreammetadata.h"

KDCVideoStreamMetaData::KDCVideoStreamMetaData(	const QString& demuxer,
																								const QString& codec,
																								const int width,
																								const int height,
																								const int bitrate,
																								const double fps,
																								const double length,
																								const double aspect )
{
	p_demuxer = demuxer;
	p_codec = codec;
	p_bitrate = bitrate;
	p_fps = fps;
	p_width = width;
	p_height = height;
	p_length = qRound( length*1000.0 );
	p_frameCount = qRound( fps*length );
	p_aspect = aspect;
}

int KDCVideoStreamMetaData::frameCount() const
{
	return p_frameCount;
}

QString KDCVideoStreamMetaData::demuxer() const
{
	return p_demuxer;
}

QString KDCVideoStreamMetaData::codec() const
{
	return p_codec;
}

double KDCVideoStreamMetaData::aspectRatio() const
{
	return p_aspect;
}

int KDCVideoStreamMetaData::width() const
{
	return p_width;
}

int KDCVideoStreamMetaData::height() const
{
	return p_height;
}

int KDCVideoStreamMetaData::bitrate() const
{
	return p_bitrate;
}

double KDCVideoStreamMetaData::fps() const
{
	return p_fps;
}

int KDCVideoStreamMetaData::length() const
{
	return p_length;
}
