/***************************************************************************
 *   Copyright (C) 2007 by Marcin Swiechowicz   *
 *   marcin.swiechowicz@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "kdcaspectratiocombobox.h"

#include "../../kdcdisc.h"

#include <QVariant>

KDCAspectRatioComboBox::KDCAspectRatioComboBox( const KDCMovie *movie, QWidget *parent )
	: KComboBox( parent )
{
	if ( movie->disc()->discType() == KDC::DVD )
	{
		addItem( "4:3", KDC::LetterBox );
		addItem( "16:9", KDC::WideScreen );
	}
	else
		addItem( "4:3", KDC::LetterBox );

	setCurrentIndex( findData( movie->videoStream()->aspectRatio() ) );
	connect( this, SIGNAL( currentIndexChanged( int ) ), this, SLOT( on_currentIndexChanged( int ) ) );
}

KDCAspectRatioComboBox::~KDCAspectRatioComboBox()
{

}

KDC::AspectRatio KDCAspectRatioComboBox::currentAspectRatio() const
{
	int idx = itemData( currentIndex() ).toInt();
	if ( idx == 0 )
		return KDC::LetterBox;
	else
		return KDC::WideScreen;
}

void KDCAspectRatioComboBox::on_currentIndexChanged( int )
{
	emit currentAspectRatioChanged( currentAspectRatio() );
}
