/***************************************************************************
 *   Copyright (C) 2007 by Marcin Swiechowicz   *
 *   marcin.swiechowicz@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "kdcresolutiondelegate.h"

#include "kdcresolutioncombobox.h"

#include <QModelIndex>

KDCResolutionDelegate::KDCResolutionDelegate( QObject *parent )
	: QItemDelegate( parent )
{
	p_movie = NULL;
}

void KDCResolutionDelegate::setCurrentData( const KDCMovie *movie )
{
	p_movie = movie;
}

QWidget* KDCResolutionDelegate::createEditor( QWidget *parent, const QStyleOptionViewItem& option, const QModelIndex& index ) const
{
	KDCResolutionComboBox *editor = new KDCResolutionComboBox( p_movie, parent );
	connect( editor, SIGNAL( currentResolutionChanged( int, int ) ), this, SLOT( on_resolutionChanged( int, int ) ) );
	return editor;
}

void KDCResolutionDelegate::setModelData( QWidget *editor, QAbstractItemModel *model, const QModelIndex& index) const
{
	KDCResolutionComboBox *tmp = static_cast<KDCResolutionComboBox*>( editor );
	model->setData( index, tmp->currentText() );
}

void KDCResolutionDelegate::updateEditorGeometry( QWidget *editor, const QStyleOptionViewItem& option, const QModelIndex& index) const
{
	editor->setGeometry( option.rect );
}

void KDCResolutionDelegate::on_resolutionChanged( int width, int height )
{
	emit resolutionChanged( width, height );
}
