/***************************************************************************
 *   Copyright (C) 2007 by Marcin Swiechowicz   *
 *   marcin.swiechowicz@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "kdcdiscsizestatusbar.h"

#include <QHBoxLayout>

#include <KLocale>
#include <kio/job.h>

KDCDiscSizeStatusBar::KDCDiscSizeStatusBar( QWidget *parent )
	: QWidget( parent )
{
	p_progress = new QProgressBar;
	p_progress->setMinimumHeight( 20 );
	p_progress->setMaximumHeight( 20 );
	p_progress->setFormat( i18n("0.0 B  / %p%") );
	p_progress->setValue( 0 );

	QHBoxLayout *hLayout = new QHBoxLayout( this );
	hLayout->addWidget( p_progress );
}

KDCDiscSizeStatusBar::~KDCDiscSizeStatusBar()
{

}

void KDCDiscSizeStatusBar::updateInfo( KDC::MediaSize mediaSize, quint64 size )
{
	p_progress->setMaximum( mediaSize );
	if ( size > mediaSize )
	{
		int percent = qRound( size/(double)mediaSize*100 );
		p_progress->setValue( mediaSize );
		p_progress->setFormat( KIO::convertSizeFromKiB( size ) + " / " + QString::number( percent ) + "%" );
	}
	else
	{
		p_progress->setValue( size );
		p_progress->setFormat( KIO::convertSizeFromKiB( size ) + " / %p%"  );
		p_progress->update();
	}
}

void KDCDiscSizeStatusBar::reset()
{
	p_progress->setFormat( i18n("0.0 B  / %p%") );
	p_progress->setValue( 0 );
}
