/***************************************************************************
 *   Copyright (C) 2007 by Marcin Swiechowicz   *
 *   marcin.swiechowicz@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef KDCLABEL_H
#define KDCLABEL_H

#include <QLabel>
#include <QString>
#include <QVariant>
#include <QColor>

class KDCLabel : public QLabel
{
Q_OBJECT
public:
	enum Mode { NORMAL, BLACKTITLE, TITLE, FRAME, INFO };
	KDCLabel( Mode mode = NORMAL, QWidget *parent = 0 );
	KDCLabel( const QString& str, Mode mode = NORMAL, QWidget *parent = 0 );
	KDCLabel( const QString& str, const QColor& color, Mode mode = NORMAL, QWidget *parent = 0 );
	~KDCLabel();
	void setCurrentMode( KDCLabel::Mode );
	void setPointSize( uint size );
	void setData( QVariant data );
	QVariant data() const;
	void setColor( const QColor& color );
signals:
	void clicked();
protected:
	void mousePressEvent( QMouseEvent * event );
private:
	QVariant p_data;
};
#endif
