/***************************************************************************
 *   Copyright (C) 2007 by Marcin Swiechowicz   *
 *   marcin.swiechowicz@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef KDCOUTPUTDIRSTATUSBAR_H
#define KDCOUTPUTDIRSTATUSBAR_H

#include "kdclabel.h"
#include "kdcnamespace.h"
#include "../lib/kdclib.h"

#include <QString>
#include <QPixmap>
#include <QTimerEvent>
#include <QBasicTimer>

class KDCOutputDirStatusBar : public QWidget
{
Q_OBJECT
public:
	KDCOutputDirStatusBar( QWidget *parent = 0 );
	~KDCOutputDirStatusBar();
	void setProjectSize( quint64 size );
	void setOutputPath( const QString& path );
	void setProjectInfo( const QString& path, quint64 size );
	void setIconSize( int size = 20 );
	QString outputPath() const;
	QString mountPoint() const;
	quint64 freeSize() const;
	quint64 totalSize() const;
	quint64 projectSize() const;
	void setTextColor( const QColor& color );
public slots:
	void reset();
	void refresh();
	void start();
	void stop();
protected:
	void timerEvent( QTimerEvent *event );
private slots:
	void on_foundMountPoint( const QString&, quint64, quint64, quint64 );
private:
	KDCLabel *p_caption;
	KDCLabel *p_icon;
	quint64 p_freeSize;
	quint64 p_projectSize;
	quint64 p_totalSize;
	int p_size;
	QString p_path;
	QBasicTimer *p_timer;
	QString p_mountPoint;
};
#endif
