/***************************************************************************
 *   Copyright (C) 2007 by Marcin Swiechowicz   *
 *   marcin.swiechowicz@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef KDCPROGRESSBAR_H
#define KDCPROGRESSBAR_H

#include <QList>
#include <QProgressBar>

// Smart ProgressBar

class KDCProgressBar : public QProgressBar
{
Q_OBJECT
public:
	KDCProgressBar( QWidget *parent = 0 );
	~KDCProgressBar();
	void setTotalSize( int size );
	void setProgress( int val );
	void setNewValue( int val );
	void setPercent( int val );
	int totalSize() const;
	int percent() const;
	int currentValue() const;
	void refresh();
signals:
	void percentChanged( int oldPercent, int newPercent );
private:
	int p_totalSize;
	QList<int> p_ranges;
	QList<int>::const_iterator it;
	int p_percent;
	int p_value;

	void createRanges( const int max );
};
#endif
